#include "number_direction_freedom_heuristic.hpp"
#include "penguin.hpp"
using namespace std;


//Count the number of direction in which a penguin can move
  uint8_t number_of_direction_penguin(uint32_t penguin){
    uint8_t res = 0 ;
    if(PENGUIN_MOVES_A(penguin)>0) res++;
    if(PENGUIN_MOVES_B(penguin)>0) res++;
    if(PENGUIN_MOVES_C(penguin)>0) res++;
    if(PENGUIN_MOVES_D(penguin)>0) res++;
    if(PENGUIN_MOVES_E(penguin)>0) res++;
    if(PENGUIN_MOVES_F(penguin)>0) res++;
    return res;
  }

namespace mcts
{
  float number_direction_freedom_heuristic::get_value(const game::penguin& game, uint8_t move) const
  {
	    
	  std::shared_ptr<game::penguin> played = game::copy(game);
	  //game::penguin_state before_state = played->get_state();
	  played->play(move);
	  game::penguin_state after_state = played->get_state();
	  
      uint32_t* tab_peng = after_state.peng_red;
      uint8_t nb = 0;
      if(!after_state.current_player_red) {
       tab_peng = after_state.peng_blue;
      }
      for(int i = 0; i < 4; ++i) {
        nb += number_of_direction_penguin(tab_peng[i]);
      }
      
	  return (-12.f + (float)nb)/12.f;

  }

  int number_direction_freedom_heuristic::get_count(const game::penguin& game, uint8_t move) const
  {
    return 10000000 / (game.turns_played() + 1);
  }

}
